﻿using RimWorld;
using Verse;

namespace VREAndroids
{
    public class Gene_SolarFlareVulnerability : Gene
    {
        public OverlayHandle? overlayPowerOff;
        public override void Tick()
        {
            base.Tick();
            if (pawn.Spawned && pawn.Map.gameConditionManager.ElectricityDisabled || Find.World.gameConditionManager.ElectricityDisabled)
            {
                if (pawn.stances != null && pawn.stances.curStance is not Stance_Stand)
                {
                    pawn.stances.SetStance(new Stance_Stand(9999999, pawn.Position + pawn.Rotation.FacingCell, null));
                }

                if (pawn.MentalStateDef != VREA_DefOf.VREA_SolarFlared)
                {
                    if (pawn.InMentalState)
                    {
                        pawn.mindState.mentalStateHandler.CurState.RecoverFromState();
                    }
                    pawn.mindState.mentalStateHandler.TryStartMentalState(VREA_DefOf.VREA_SolarFlared);
                }

                if (overlayPowerOff is null)
                {
                    if (pawn.Spawned)
                    {
                        overlayPowerOff = pawn.Map.overlayDrawer.Enable(pawn, OverlayTypes.PowerOff);
                    }
                }
            }
        }
    }
}
